;(defparameter *array* ())
; ces fonctions remplissent les vides dans les analyses AddAn, de facon  avoir
; des partiels continus pour la resynthse Max




(om::defmethod! readLAdd0 ((infile t)
                           (nharmsmax t)
                           &optional (nmaxframe '()))
        


 :initvals (list '() '())
 :indoc '("filename" "nharmsmax" "nmaxframe")
 :icon 135
 :doc "reads additive analysis data and returns lists of freqs and amps"


;(defun readLAdd0 (infile nharmsmax &optional nmaxframe)
  (let ((infile (if (equal infile 'nil) (choose-file-dialog ) infile))
        (Ldats  ())(Llfreqs  ())(Llamps ()) Lfreqs Lamps
        (frame 1)(current 0) index
        (array (make-array (list nharmsmax 3)))) ; 3 analyses, nvals donnes , 3 params f a ph
    (if (not nmaxframe) (setf nmaxframe -1))
    (with-open-file (input-stream infile :direction :input)
      
      (do ((nvals (read input-stream nil :eof)(read input-stream nil :eof)))
          ((or (eq :eof nvals)(= nmaxframe frame)))
        (setf Lfreqs ())
        (setf Lamps ())
       
        (push (read input-stream nil :eof)  Ldats )        ;---> date
        ;(init-array array nharmsmax 3)
        (setf array (make-array (list nharmsmax 3)))
        
        (dotimes (i nvals)
          (setf index (1- (read input-stream nil :eof)))   ;------> index
          ;(print index)
          (if (< index nharmsmax)
            (dotimes (j 3)
              (setf (aref array index j) (read input-stream nil :eof)))
            (dotimes (j 3) (read input-stream nil :eof)    ;------> ignore harmo superieurs
                     )))
        
        (dotimes (i nharmsmax)
          (push (aref array (- nharmsmax i 1) 0) Lfreqs)
          (push (aref array (- nharmsmax i 1) 1) Lamps))
        (push Lfreqs LLfreqs)
        (push Lamps LLamps)
        (setf frame (print (incf frame))))
      (list (reverse ldats)(reverse LLfreqs)(reverse llamps)))
    ))
    
;(readLAdd0 nil 5 10)
;(readLAdd0 nil 5)
;(length (readLAdd0 nil 80))

#|

(defparameter *toto* (make-array (list 5 3)))
*toto*

|#


(Defun readAdd0 (infile outfile nharmsmax)
   "doc : flag 0 = les valeurs absentes sont remplaces par des zeros, retourne un coll pour Max"
   
   (let ((infile (if (equal infile 'nil) (choose-file-dialog ) infile))
         (outfile (if (equal outfile 'nil) (choose-new-file-dialog ) outfile))
         (frame 1)(current 0) index
         (array (make-array (list nharmsmax 3)))) ; 3 analyses, nvals donnes , 3 params f a ph
     
     (with-open-file (input-stream infile :direction :input)
       (with-open-file (output-stream outfile :direction :output :if-exists :supersede)
         
         
         (do ((nvals (read input-stream nil :eof)(read input-stream nil :eof)))
             ((eq :eof nvals))
           
           (read input-stream nil :eof)           ;---> date
           ;(init-array array nharmsmax 3)
           (setf array (make-array (list nharmsmax 3)))
           
           (dotimes (i nvals)
             (setf index (1- (read input-stream nil :eof)))   ;------> index
             (if (< index nharmsmax)
               (dotimes (j 3)
                 (setf (aref array index j) (read input-stream nil :eof)))
               (dotimes (j 3) (read input-stream nil :eof)))
             )
           
           (write-data0 output-stream array frame nharmsmax)
           (setf frame (print (incf frame)))
           
           )
         (format t "j'cris dans le fichier ~a" outfile)))))
    
;(readAdd0 (choose-file-dialog) "LP-FW-20Go:dvlpt-LP:GMEM:Murail:Juillet:MurailTemp:gong0b.txt" 80)
;(readAdd0 (choose-file-dialog) "LP-FW-20Go:dvlpt-LP:GMEM:Murail:Juillet:MurailTemp:gong0c2p.txt" 10)

(defun write-data (outfile array current frame nharmo flag)
  (format outfile "~a\, " frame)
  (case flag
    (0       ; 
     (dotimes (n nharmo)
       (format outfile "~a ~a " (aref array current n 0)(aref array current n 1))))
    (1
     (dotimes (n nharmo)
       (format outfile "~a ~a " (aref array current n 0)(aref array current n 1))))
    (2
     (dotimes (n nharmo)
       (let ((f (aref array current n 0)))
         (if (zerop f)
           ())   ; probleme pour ecrire n,il faut connaitre n+1 !!!!!!!!
         (format outfile "~a ~a " (aref array current n 0)(aref array current n 1))))))
  (format outfile "\;~%" frame))

(defun write-data (outfile array current frame nharmo flag)
  (format outfile "~a\, " frame)
  (case flag
    (0       ; 
     (dotimes (n nharmo)
       (format outfile "~a ~a " (aref array current n 0)(aref array current n 1))))
    (1
     (dotimes (n nharmo)
       (format outfile "~a ~a " (aref array current n 0)(aref array current n 1))))
    (2
     (dotimes (n nharmo)
       (let ((f (aref array current n 0)))
         (if (zerop f)
           ())   ; probleme pour ecrire n,il faut connaitre n+1 !!!!!!!!
         (format outfile "~a ~a " (aref array current n 0)(aref array current n 1))))))
  (format outfile "\;~%" frame))

(defun write-data0 (outfile array frame nharmsmax)
  (format outfile "~a\, " frame)
  (dotimes (n nharmsmax)
    (format outfile "~9,2F~9,4F" (aref array n 0)(aref array n 1)))
  (format outfile "\;~%" frame))

(defun write-data1 (outfile array current frame nharmsmax)
  (format outfile "~a\, " frame)
  (dotimes (n nharmsmax)
    (format outfile "~9,2F~9,4F" (aref array current n 0)(aref array current n 1)))
  (format outfile "\;~%" frame))

(defun init-array (array x y)
  (setf array (make-array (list x y))))

(defun init-subarray (array n ny nz)
  (dotimes (y ny)
    (dotimes (z nz)
      (setf (aref array n y z) 0))))

;***************************************************************

(defun readAdd1old (infile outfile nharmo flag)
  "doc : flag 0 = les valeurs absen,tes sont remplaces par des zeros
flag 1 = les valeurs absentes sont remplaces par des valeurs de frquences interpoles sur les 
frquences inf et sup immdiates dans la meme frame
flag 2 = 
voir affichage des rationnels"
  (with-open-file (input-stream infile :direction :input)
    (with-open-file (output-stream outfile :direction :output :if-exists :supersede)
      (let ((frame 1)(current 0) index prev-index
            (array (make-array (list 3 nharmo 3)))) ; 3 analyses, nvals donnes , 3 params f a ph
        ; previous current next a tourne
        
        (do ((nvals (read input-stream nil :eof)(read input-stream nil :eof)))
            ((eq :eof (print nvals)))
          
          (progn (read input-stream nil :eof)  ;---> date
                 
                 (init-subarray array current nharmo 3)
                 (setf prev-index 0)
                 
                 (dotimes (i nvals)
                   
                   (progn 
                     ;(format output-stream "i = ~a~%" i)
                     (setf index (1- (read input-stream nil :eof)))  ;------> index
                     
                     (dotimes (j 3)
                       (setf (aref array current index j) (read input-stream nil :eof)))
                     
                     (case flag                                      ;--------> recherche des fund manquantes
                       (1 
                        (if (not (= prev-index index))
                          (let ((fundinf (/ (aref array current prev-index 0)(1+ prev-index)))
                                (fundsup (/ (aref array current index 0) (1+ index)))
                                fund)
                            
                            (setf fund 
                                  (cond 
                                   ((zerop fundinf)
                                    fundsup)
                                   ((zerop fundsup)
                                    fundinf)
                                   (t
                                    (* 1/2 (+ fundinf fundsup)))))
                            
                            (dotimes (k (- index prev-index))
                              
                              ;(print (list fundinf fundsup))
                              (setf (aref array current (+ k prev-index) 0) (* fund (+ 1 k prev-index)))
                              
                              )))))
                     
                     (setf prev-index (incf index))
                     ))
                 
                 ;(print (list "prev-index------>" prev-index))
                 (case flag 
                   (1
                    (if (< prev-index nharmo)
                      
                      (let ((fund (/ (aref array current (1- prev-index) 0) prev-index)))
                        
                        (dotimes (k (- nharmo prev-index))
                          (setf (aref array current (+ k prev-index) 0) (* fund (+ 1 k prev-index))))))))
                 
                 (write-data output-stream array current frame nharmo flag)
                 (setf current (mod (incf current) 3)
                       frame (incf frame))))
        
        ; (setf *array* array)
        ))))



(defun readAdd1 (infile outfile nharmsmax)
   "doc : flag 1 = les valeurs absentes sont remplaces par des valeurs de frquences interpoles sur les 
frquences inf et sup immdiates dans la meme frame
pas complement ok comme fonction en fins de lignes"
   (let ((infile (if (equal infile 'nil) (choose-file-dialog ) infile))
         (outfile (if (equal outfile 'nil) (choose-new-file-dialog ) outfile))
         (frame 1)(current 0) index prev-index fund
         (array (make-array (list 3 nharmsmax 3)))) ; 3 analyses, nvals donnes , 3 params f a ph
     
     (with-open-file (input-stream infile :direction :input)
       (with-open-file (output-stream outfile :direction :output :if-exists :supersede)
         
         (do ((nvals (read input-stream nil :eof)(read input-stream nil :eof)))
             ((eq :eof nvals))
           
           (read input-stream nil :eof)  ;---> date
           (init-subarray array current nharmsmax 3)
           (setf prev-index 0)
           ;(print (list "previndex " prev-index))
           
           (dotimes (i nvals)
             
             (setf index (1- (read input-stream nil :eof)))  ;------> index
             
             (if (< index nharmsmax)
               (progn 
                 (dotimes (j 3)
                   (setf (aref array current index j) (read input-stream nil :eof)))
                 
                 (if (not (= prev-index index))   ;--> l'index trouv est-il le suivant ou yatil un trou ?
                   (let ((fundinf (/ (aref array current prev-index 0)(1+ prev-index)))
                         (fundsup (/ (aref array current index 0) (1+ index))))
                     ;(print (list "prei index - inf - sup" prev-index index fundinf fundsup))
                     (setf fund (cond 
                                 ((zerop fundinf) fundsup)
                                 ((zerop fundsup) fundinf)
                                 (t (* 1/2 (+ fundinf fundsup)))))
                     
                     (dotimes (k (- index prev-index))
                       (setf (aref array current (+ k prev-index) 0) (* fund (+ 1 k prev-index)))
                       ))))
               
               (dotimes (j 3) (read input-stream nil :eof)))
             
             (setf prev-index (1+ index)))
           
           ;pour les valeurs sup au dernier index
           (dotimes (k (- nharmsmax index))
             (setf fund (/ (aref array current index 0) (1+ index))
                   (aref array current (+ k index) 0) (* fund (+ 1 k prev-index))))
           
           (write-data1 output-stream array current frame nharmsmax)
           (setf current (mod (incf current) 3)
                 frame (print (incf frame))))
         
         (format t "j'cris dans le fichier ~a" outfile)))))



;**********************************************************

;(defparameter *array* ())

(defun readAdd2 (infile outfile nharmsmax)
   "doc : flag 2 = si la frequence est presente dans l'analyse prec ou suivante, on prend cette valeur
ou la moyenne des deux, sinon on met zero
input = diphone add file
output = coll pour max"
   
   (let ((infile (if (equal infile 'nil) (choose-file-dialog ) infile))
         (outfile (if (equal outfile 'nil) (choose-new-file-dialog ) outfile))
         (frame 1) index prev-index
         (array (make-array (list 3 nharmsmax 3)))) ; 3 analyses, nvals donnes , 3 params f a ph
     
     (with-open-file (input-stream infile :direction :input)
       (with-open-file (output-stream outfile :direction :output :if-exists :supersede)
         
         (do ((nvals (read input-stream nil :eof)(read input-stream nil :eof)))
             ((eq :eof nvals))
           
           (read-addframe2 input-stream array frame nharmsmax nvals)
           (if (> frame 1)
             (write-addframe2 input-stream output-stream array (- frame 1) nharmsmax))
           (setf frame (print (incf frame))))
         
         (write-addframe2 input-stream output-stream array (- frame 1) nharmsmax)
         ))))
  
(defun read-addframe2 (input-stream array frame nharmsmax nvals)
   (let ((current (mod frame 3)))
     (read input-stream nil :eof)  ;---> date
     (init-subarray array (mod frame 3) nharmsmax 3)
     (setf prev-index 0)
     
     (dotimes (i nvals)
       
       (setf index (1- (read input-stream nil :eof)))  ;------> index
       
       (if (< index nharmsmax)
         (dotimes (j 3)
           (setf (aref array current index j) (read input-stream nil :eof)))
         (dotimes (j 3) (read input-stream nil :eof)))
       
       )))

(defun write-addframe2 (input-stream output-stream array frame nharmsmax)
   (let ((current (mod frame 3)) freq)
     
     (format output-stream "~a\, " frame)
     (dotimes (i nharmsmax)
       (setf freq (aref array current i 0))
       (if (zerop freq)
         (cond
          ((and (zerop (aref array (mod (1- current) 3) i 0)) (zerop (aref array (mod (1+ current) 3) i 0)))
           ())
          ((zerop (aref array (mod (1- current) 3) i 0))
           (setf (aref array current i 0) (aref array (mod (1+ current) 3) i 0)))
          ((zerop (aref array (mod (1+ current) 3) i 0))
           (setf (aref array current i 0) (aref array (mod (1- current) 3) i 0)))
          (t
           (setf (aref array current i 0) (/ (+ (aref array (mod (1- current) 3) i 0)
                                                (aref array (mod (1- current) 3) i 0)) 2)))))

         (format output-stream "~9,2F~9,4F" (aref array current i 0)(aref array current i 1)))
       (format output-stream "\;~%" frame)))



;**********************************************************


;********** mlange de 2 et de 1 : ************************
;********** on ajoute une valeur apres disparition et avant apparition
;********** on remplace les zeros quji restent par des multiples de la fondamentale

(defun readAdd12 (infile outfile nharmsmax)
   "doc : flag 2 = si la frequence est presente dans l'analyse prec ou suivante, on prend cette valeur
ou la moyenne des deux, sinon on met zero
input = diphone add file
output = coll pour max"
   
   (let ((infile (if (equal infile 'nil) (choose-file-dialog ) infile))
         (outfile (if (equal outfile 'nil) (choose-new-file-dialog ) outfile))
         (frame 1) index prev-index fund0 fund1
         (array (make-array (list 3 nharmsmax 3)))) ; 3 analyses, nvals donnes , 3 params f a ph
     
     (with-open-file (input-stream infile :direction :input)
       (with-open-file (output-stream outfile :direction :output :if-exists :supersede)
         
         (do ((nvals (read input-stream nil :eof)(read input-stream nil :eof)))
             ((eq :eof nvals))
           ; on lit la frame n et on ecrit une frame n-1
          ; (print fund0)
          ; (print array)
          (setf fund0 (read-addframe12 input-stream array frame nharmsmax nvals))
           (if (> frame 1)
             (write-addframe12 input-stream output-stream array (- frame 1) nharmsmax fund1))
           (setf fund1 fund0)
     
           (setf frame (print (incf frame))))
         
         (write-addframe12 input-stream output-stream array (- frame 1) nharmsmax fund1)
         ))))
  
(defun read-addframe12 (input-stream array frame nharmsmax nvals)
   (let ((current (mod frame 3))(fund nil))
     (read input-stream nil :eof)  ;---> date
     (init-subarray array (mod frame 3) nharmsmax 3)
     (setf prev-index 0)
     
     (dotimes (i nvals fund)
       
       (setf index (1- (read input-stream nil :eof)))  ;------> index
       
       (if (< index nharmsmax)
         (dotimes (j 3)
           (setf (aref array current index j) (read input-stream nil :eof)))
         (dotimes (j 3) (read input-stream nil :eof)))
       
       (if (not fund)
         (setf fund (/ (aref array current index 0) (1+ index))))
       
       )))

(defun write-addframe12 (input-stream output-stream array frame nharmsmax fund)
   (let ((current (mod frame 3)) freq)
     
     (format output-stream "~a\, " frame)
    ; (print (list "2" fund))
     (dotimes (i nharmsmax)
       (setf freq (aref array current i 0))
       (if (zerop freq)
         (cond
          ((or (zerop (aref array (mod (1- current) 3) i 0)) (zerop (aref array (mod (1+ current) 3) i 0)))
           (setf (aref array current i 0) (* (1+ i) fund)))
        ;  ((zerop (aref array (mod (1- current) 3) i 0))
        ;   (setf (aref array current i 0) (aref array (mod (1+ current) 3) i 0)))
        ;  ((zerop (aref array (mod (1+ current) 3) i 0))
        ;   (setf (aref array current i 0) (aref array (mod (1- current) 3) i 0)))
          (t
           (setf (aref array current i 0) (/ (+ (aref array (mod (1- current) 3) i 0)
                                                (aref array (mod (1- current) 3) i 0)) 2)))))
       
       (format output-stream "~9,2F~9,4F" (aref array current i 0)(aref array current i 1)))
     (format output-stream "\;~%" frame)))




;********************************************************

;(defparameter *array* ())

;**********************************************************

(defun readAdd3 (infile outfile nharmsmax seuil)
   "doc : flag 3 = meme chose que dflag 2 mais si un colonne est totalement vide, on la saute"
   (let ((frame 1) index prev-index (Lindex (make-array 512)) Lindex2
         (array (make-array (list 3 nharmsmax 3)))) ; 3 analyses, nvals donnes , 3 params f a ph
     
     ;premier passage pour voir s'il y a des vides
     
     (with-open-file (input-stream infile :direction :input)
       
       (do ((nvals (read input-stream nil :eof)(read input-stream nil :eof)))
           ((eq :eof nvals))
         
         (read-addframe3a input-stream nharmsmax nvals Lindex seuil)
         ))
     
     (setf Lindex2 (removepartiels0 Lindex))   ; liste des index de partiels existants
     
     ;deuxieme passage pour ecrire
     
     (with-open-file (input-stream infile :direction :input)
       (with-open-file (output-stream outfile :direction :output :if-exists :supersede)

         (write-Lindex output-stream Lindex2)  ; ligne 0 dans coll --> liste des rangs
         
         (do ((nvals (read input-stream nil :eof)(read input-stream nil :eof)))
             ((eq :eof nvals))
           
           (read-addframe3b input-stream array frame nharmsmax nvals Lindex seuil)
           ;;(print array)
           (if (> frame 1)
             (write-addframe3 input-stream output-stream array (- frame 1) nharmsmax Lindex2))
           
           (setf frame (print (incf frame))))
         (write-addframe3 input-stream output-stream array (- frame 1) nharmsmax Lindex2)))))


(defun read-addframe3a (input-stream nharmsmax nvals Lindex seuil)
   (let (index)
     ;(print Lindex)
     (read input-stream nil :eof)  ;---> date
     (dotimes (i nvals)
       
       (setf index (1- (read input-stream nil :eof)))  ;------> index
       
       (read input-stream nil :eof)      ; freq 
       (if (and (> (read input-stream nil :eof) seuil)(< index 512))
         (setf (aref Lindex index) t))
       (read input-stream nil :eof)      ; phase 
       )))

(defun read-addframe3b (input-stream array frame nharmsmax nvals Lindex seuil)
   
   (let (index)
     (read input-stream nil :eof)  ;---> date
     (dotimes (i nvals)
       
       (setf index (1- (read input-stream nil :eof)))  ;------> index
       
       (if (< index nharmsmax)
         (dotimes (j 3)
           (setf (aref array (mod frame 3) index j) (read input-stream nil :eof)))
         (dotimes (j 3) (read input-stream nil :eof)))
       )))


(defun removepartiels0 (array)
  (let ((L ())(count 0)(max (array-dimensions array)))
    (dotimes  (n (first max) (reverse L))
      (if (not (numberp (aref array n)))
        (push count L))
      (setf count (incf count)))))


(defun removepartiels1 (liste)
  (let ((L ())(count 0))
    (dolist  (elt liste (reverse L))
      (if (not (numberp elt))
        (push count L))
      (setf count (incf count)))))


(defun write-addframe3 (input-stream output-stream array frame nharmsmax Lindex)
   (let ((current (mod frame 3)) freq)
     
     (format output-stream "~a\, " frame)
     (dotimes (i nharmsmax)
       (if (find i Lindex)
         (progn
           (setf freq (aref array current i 0))
           (if (zerop freq)
             (cond
              ((and (zerop (aref array (mod (1- current) 3) i 0)) (zerop (aref array (mod (1+ current) 3) i 0)))
               ())
              ((zerop (aref array (mod (1- current) 3) i 0))
               (setf (aref array current i 0) (aref array (mod (1+ current) 3) i 0)))
              ((zerop (aref array (mod (1+ current) 3) i 0))
               (setf (aref array current i 0) (aref array (mod (1- current) 3) i 0)))
              (t
               (setf (aref array current i 0) (/ (+ (aref array (mod (1- current) 3) i 0)
                                                    (aref array (mod (1- current) 3) i 0)) 2)))))
           
           (format output-stream "~9,2F~9,4F" (aref array current i 0)(aref array current i 1)))))
     (format output-stream "\;~%" frame)))

(defun write-Lindex (output-stream  Lindex)
   (format output-stream "0\, " )
   (dolist (index Lindex)
     (format output-stream "~a " (1+ index )))
   (format output-stream "\;~%"))
  


